## libyang2 2.0.112

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

# force out-of-source build
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
    message(FATAL_ERROR "In-source build is not allowed. Please make a standalone build directory and run CMake from there. You may need to remove CMakeCache.txt.")
endif()

project(libyang C)

# include custom Modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/CMakeModules/")

include(GNUInstallDirs)
include(CheckSymbolExists)
include(UseCompat)
include(ABICheck)
include(SourceFormat)
include(GenDoc)
include(GenCoverage)

# set default build type if not specified by user
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()
# normalize build type string
# see https://github.com/CESNET/libyang/pull/1692 for why CMAKE_C_FLAGS_<type> are not used directly
string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_TYPE_UPPER)
if ("${BUILD_TYPE_UPPER}" STREQUAL "RELEASE")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-DNDEBUG -O2 ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG")
    set(CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-g3 -O0 ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBINFO")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Build Type" FORCE)
elseif("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBUG")
    set(CMAKE_BUILD_TYPE "RelWithDebug" CACHE STRING "Build Type" FORCE)
elseif("${BUILD_TYPE_UPPER}" STREQUAL "ABICHECK")
    set(CMAKE_BUILD_TYPE "ABICheck" CACHE STRING "Build Type" FORCE)
    set(CMAKE_C_FLAGS "-g -Og ${CMAKE_C_FLAGS}")
elseif("${BUILD_TYPE_UPPER}" STREQUAL "DOCONLY")
    set(CMAKE_BUILD_TYPE "DocOnly" CACHE STRING "Build Type" FORCE)
endif()

# check the supported platform
if(NOT UNIX)
    message(FATAL_ERROR "Only *nix like systems are supported.")
endif()

#
# variables
#

set(LIBYANG_DESCRIPTION "libyang is YANG data modelling language parser and toolkit written (and providing API) in C.")

# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

# keep all binaries in the build directory
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# set version of the project
set(LIBYANG_MAJOR_VERSION 2)
set(LIBYANG_MINOR_VERSION 0)
set(LIBYANG_MICRO_VERSION 112)
set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
# set version of the library
set(LIBYANG_MAJOR_SOVERSION 2)
set(LIBYANG_MINOR_SOVERSION 13)
set(LIBYANG_MICRO_SOVERSION 7)
set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})

# global C flags
set(CMAKE_C_FLAGS                "${CMAKE_C_FLAGS} -Wall -Wextra -Wpedantic -std=c11")

include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_SOURCE_DIR}/src)

# type plugins are separate because they have their documentation generated
set(type_plugins
    src/plugins_types/binary.c
    src/plugins_types/bits.c
    src/plugins_types/boolean.c
    src/plugins_types/decimal64.c
    src/plugins_types/empty.c
    src/plugins_types/enumeration.c
    src/plugins_types/identityref.c
    src/plugins_types/instanceid.c
    src/plugins_types/integer.c
    src/plugins_types/leafref.c
    src/plugins_types/string.c
    src/plugins_types/union.c
    src/plugins_types/ipv4_address.c
    src/plugins_types/ipv4_address_no_zone.c
    src/plugins_types/ipv6_address.c
    src/plugins_types/ipv6_address_no_zone.c
    src/plugins_types/ipv4_prefix.c
    src/plugins_types/ipv6_prefix.c
    src/plugins_types/date_and_time.c
    src/plugins_types/xpath1.0.c
    src/plugins_types/node_instanceid.c)

set(libsrc
    src/common.c
    src/log.c
    src/hash_table.c
    src/set.c
    src/path.c
    src/diff.c
    src/context.c
    src/json.c
    src/tree_data.c
    src/tree_data_free.c
    src/tree_data_helpers.c
    src/tree_data_hash.c
    src/parser_xml.c
    src/parser_json.c
    src/parser_lyb.c
    src/out.c
    src/printer_data.c
    src/printer_xml.c
    src/printer_json.c
    src/printer_lyb.c
    src/schema_compile.c
    src/schema_compile_node.c
    src/schema_compile_amend.c
    src/schema_features.c
    src/tree_schema.c
    src/tree_schema_free.c
    src/tree_schema_helpers.c
    src/in.c
    src/lyb.c
    src/parser_yang.c
    src/parser_yin.c
    src/parser_stmt.c
    src/printer_schema.c
    src/printer_yang.c
    src/printer_yin.c
    src/printer_tree.c
    src/plugins.c
    src/plugins_types.c
    src/plugins_exts.c
    src/plugins_exts/metadata.c
    src/plugins_exts/nacm.c
    src/plugins_exts/yangdata.c
    src/xml.c
    src/xpath.c
    src/validation.c
    ${type_plugins})

set(headers
    src/context.h
    src/dict.h
    src/in.h
    src/libyang.h
    src/log.h
    src/out.h
    src/parser_data.h
    src/parser_schema.h
    src/plugins.h
    src/plugins_exts.h
    src/plugins_exts_compile.h
    src/plugins_exts_print.h
    src/plugins_types.h
    src/printer_data.h
    src/printer_schema.h
    src/set.h
    src/tree.h
    src/tree_data.h
    src/tree_edit.h
    src/tree_schema.h)

set(internal_headers
    src/common.h
    src/diff.h
    src/hash_table.h
    src/in_internal.h
    src/json.h
    src/lyb.h
    src/out_internal.h
    src/parser_internal.h
    src/path.h
    src/plugins_internal.h
    src/printer_internal.h
    src/schema_compile.h
    src/schema_compile_amend.h
    src/schema_compile_node.h
    src/schema_features.h
    src/tree_data_internal.h
    src/tree_schema_internal.h
    src/validation.h
    src/xml.h
    src/xpath.h)

set(gen_headers
    src/version.h
    src/config.h)

# files to generate doxygen from
set(doxy_files
    doc/build.dox
    doc/transition.dox
    ${headers}
    ${PROJECT_BINARY_DIR}/src/version.h
    ${type_plugins})

# project (doxygen) logo
set(project_logo
    doc/logo.png)

# source files to be covered by the 'format' target
set(format_sources
    compat/*.c
    compat/*.h*
    src/*.c
    src/*.h
    src/plugins_exts/*
    src/plugins_types/*)
#
# options
#

if(("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG") OR ("${BUILD_TYPE_UPPER}" STREQUAL "RELWITHDEBINFO"))
    option(ENABLE_TESTS "Build tests" ON)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" ON)
else()
    option(ENABLE_TESTS "Build tests" OFF)
    option(ENABLE_VALGRIND_TESTS "Build tests with valgrind" OFF)
endif()
option(ENABLE_PERF_TESTS "Build performance tests" OFF)
option(ENABLE_COVERAGE "Build code coverage report from tests" OFF)
option(ENABLE_FUZZ_TARGETS "Build target programs suitable for fuzzing with AFL" OFF)
option(ENABLE_INTERNAL_DOCS "Generate doxygen documentation also from internal headers" OFF)

if(ENABLE_INTERNAL_DOCS)
    set(doxy_files ${doxy_files} ${internal_headers})
    set(INTERNAL_DOCS YES)
else()
    set(INTERNAL_DOCS NO)
endif()

set(LYD_VALUE_SIZE "24" CACHE STRING "Maximum size in bytes of data node values that do not need to be allocated dynamically, minimum is 8")
if(LYD_VALUE_SIZE LESS 8)
    message(FATAL_ERROR "Data node value size \"${LYD_VALUE_SIZE}\" is not valid.")
endif()
set(PLUGINS_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/libyang" CACHE STRING "Directory with libyang plugins (extensions and user types)")
set(PLUGINS_DIR_EXTENSIONS "${PLUGINS_DIR}/extensions" CACHE STRING "Directory with libyang user extensions plugins")
set(PLUGINS_DIR_TYPES "${PLUGINS_DIR}/types" CACHE STRING "Directory with libyang user types plugins")

# by default build shared library
# static build requires static libpcre2 library
option(ENABLE_STATIC "Build static (.a) library" OFF)

#
# checks
#
if(ENABLE_STATIC)
    message(STATUS "Disabling tests for static build")
    set(ENABLE_TESTS OFF)
    set(ENABLE_VALGRIND_TESTS OFF)
endif()

if(ENABLE_VALGRIND_TESTS)
    if(NOT ENABLE_TESTS)
        message(WARNING "Tests are disabled! Disabling memory leak tests.")
        set(ENABLE_VALGRIND_TESTS OFF)
    else()
        find_program(VALGRIND_FOUND valgrind)
        if(NOT VALGRIND_FOUND)
            message(WARNING "valgrind executable not found! Disabling memory leak tests.")
            set(ENABLE_VALGRIND_TESTS OFF)
        endif()
    endif()
endif()

if(ENABLE_TESTS)
    find_package(CMocka 1.0.1)
    if(NOT CMOCKA_FOUND)
        message(STATUS "Disabling tests because of missing CMocka")
        set(ENABLE_TESTS OFF)
    endif()
endif()

if(ENABLE_PERF_TESTS)
    find_path(VALGRIND_INCLUDE_DIR
        NAMES
        valgrind/callgrind.h
        PATHS
        /usr/include
        /usr/local/include
        /opt/local/include
        /sw/include
        ${CMAKE_INCLUDE_PATH}
        ${CMAKE_INSTALL_PREFIX}/include)
    if(VALGRIND_INCLUDE_DIR)
        set(HAVE_CALLGRIND 1)
    else()
        message(STATUS "Disabling callgrind macros in performance tests because of missing valgrind headers")
    endif()
endif()

if(ENABLE_COVERAGE)
    gen_coverage_enable(${ENABLE_TESTS})
endif()

if ("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG")
    # enable before adding tests to let them detect that format checking is available - one of the tests is format checking
    source_format_enable()
endif()

# generate files
configure_file(${PROJECT_SOURCE_DIR}/src/config.h.in ${PROJECT_BINARY_DIR}/src/config.h @ONLY)
configure_file(${PROJECT_SOURCE_DIR}/src/version.h.in ${PROJECT_BINARY_DIR}/src/version.h @ONLY)

# DOC-only target with no extra dependencies
if("${BUILD_TYPE_UPPER}" STREQUAL "DOCONLY")
    gen_doc("${doxy_files}" ${LIBYANG_VERSION} ${LIBYANG_DESCRIPTION} ${project_logo})
    return()
endif()

#
# targets
#

# link compat
use_compat()

# create static libyang library
if(ENABLE_STATIC)
    add_definitions(-DSTATIC)
    set(CMAKE_EXE_LINKER_FLAGS -static)
    set(CMAKE_FIND_LIBRARY_SUFFIXES .a)
    set(CMAKE_LINK_SEARCH_START_STATIC TRUE)
    set(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)       # remove -Wl,-Bdynamic
    set(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    add_library(yang STATIC ${libsrc} ${compatsrc})
else()
    set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
    add_library(yangobj OBJECT ${libsrc} ${compatsrc})
    set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
    add_library(yang SHARED $<TARGET_OBJECTS:yangobj>)

    #link dl
    target_link_libraries(yang ${CMAKE_DL_LIBS})
endif()

set_target_properties(yang PROPERTIES VERSION ${LIBYANG_SOVERSION_FULL} SOVERSION ${LIBYANG_SOVERSION})

# link math
target_link_libraries(yang m)

# find pthreads
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)
if(ENABLE_STATIC)
    target_link_libraries(yang -Wl,--whole-archive ${CMAKE_THREAD_LIBS_INIT} -Wl,--no-whole-archive)
else()
    target_link_libraries(yang ${CMAKE_THREAD_LIBS_INIT})
endif()

# find PCRE2 library
unset(PCRE2_LIBRARY CACHE)
find_package(PCRE2 10.21 REQUIRED)
include_directories(${PCRE2_INCLUDE_DIRS})
target_link_libraries(yang ${PCRE2_LIBRARIES})

# generated header list
foreach(h IN LISTS gen_headers)
    list(APPEND g_headers ${PROJECT_BINARY_DIR}/${h})
endforeach()

# install all library files
install(TARGETS yang DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${headers} ${g_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)

find_package(PkgConfig)
if(PKG_CONFIG_FOUND)
    # generate and install pkg-config file
    configure_file("libyang.pc.in" "libyang.pc" @ONLY)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    # check that pkg-config includes the used path
    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable pc_path pkg-config RESULT_VARIABLE RETURN OUTPUT_VARIABLE PC_PATH ERROR_QUIET)
    if(RETURN EQUAL 0)
    string(STRIP "${PC_PATH}" PC_PATH)
    set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
        string(REGEX MATCH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig" SUBSTR "${PC_PATH}")
        string(LENGTH "${SUBSTR}" SUBSTR_LEN)
        if(SUBSTR_LEN EQUAL 0)

=== tests/perf/CMakeLists.txt ===
set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/perf.c
    PARENT_SCOPE)

add_executable(ly_perf ${CMAKE_CURRENT_SOURCE_DIR}/perf.c $<TARGET_OBJECTS:yangobj>)
set_target_properties(ly_perf PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests")
target_link_libraries(ly_perf ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS} m)

add_test(NAME ly_perf_1000 COMMAND ly_perf 1000 10)
add_test(NAME ly_perf_100000 COMMAND ly_perf 100000 3)

=== tests/style/CMakeLists.txt ===
add_test(NAME headers
    COMMAND ${CMAKE_SOURCE_DIR}/compat/check_includes.sh ${CMAKE_SOURCE_DIR}/src/ ${CMAKE_SOURCE_DIR}/tools/lint/ ${CMAKE_SOURCE_DIR}/tools/re/)

if (${SOURCE_FORMAT_ENABLED})
    add_test(NAME format WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND make format-check)
endif()

# just compile
add_executable(cpp_compat cpp_compat.c $<TARGET_OBJECTS:yangobj>)
target_include_directories(cpp_compat BEFORE PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(cpp_compat ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS} m)
target_compile_options(cpp_compat PUBLIC "-Werror=c++-compat")

=== tests/utests/CMakeLists.txt ===

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/basic/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/data/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/extensions/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/types/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/restriction/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/node/*.c
    PARENT_SCOPE)

ly_add_utest(NAME uint8  SOURCES types/uint8.c)
ly_add_utest(NAME uint16 SOURCES types/uint16.c)
ly_add_utest(NAME uint32 SOURCES types/uint32.c)
ly_add_utest(NAME uint64 SOURCES types/uint64.c)
ly_add_utest(NAME int8   SOURCES types/int8.c)
ly_add_utest(NAME int16  SOURCES types/int16.c)
ly_add_utest(NAME int32  SOURCES types/int32.c)
ly_add_utest(NAME int64  SOURCES types/int64.c)
ly_add_utest(NAME string SOURCES types/string.c)
ly_add_utest(NAME bits   SOURCES types/bits.c)
ly_add_utest(NAME binary SOURCES types/binary.c)
ly_add_utest(NAME inet_types   SOURCES types/inet_types.c)
ly_add_utest(NAME yang_types   SOURCES types/yang_types.c)
ly_add_utest(NAME enumeration  SOURCES types/enumeration.c)
ly_add_utest(NAME instanceid   SOURCES types/instanceid.c)
ly_add_utest(NAME union        SOURCES types/union.c)
ly_add_utest(NAME boolean      SOURCES types/boolean.c)
ly_add_utest(NAME decimal64    SOURCES types/decimal64.c)
ly_add_utest(NAME empty        SOURCES types/empty.c)
ly_add_utest(NAME identityref  SOURCES types/identityref.c)
ly_add_utest(NAME leafref      SOURCES types/leafref.c)

ly_add_utest(NAME range  SOURCES restriction/test_range.c)
ly_add_utest(NAME pattern  SOURCES restriction/test_pattern.c)

ly_add_utest(NAME list  SOURCES node/list.c)

ly_add_utest(NAME common SOURCES basic/test_common.c)
ly_add_utest(NAME set SOURCES basic/test_set.c)
ly_add_utest(NAME hash_table SOURCES basic/test_hash_table.c)
ly_add_utest(NAME inout SOURCES basic/test_inout.c)
ly_add_utest(NAME context SOURCES basic/test_context.c)
ly_add_utest(NAME plugins SOURCES basic/test_plugins.c)
ly_add_utest(NAME xml SOURCES basic/test_xml.c)
ly_add_utest(NAME json SOURCES basic/test_json.c)
ly_add_utest(NAME xpath SOURCES basic/test_xpath.c)
ly_add_utest(NAME yanglib SOURCES basic/test_yanglib.c)

ly_add_utest(NAME schema SOURCES schema/test_schema.c schema/test_schema_common.c schema/test_schema_stmts.c schema/test_schema_extensions.c)
ly_add_utest(NAME parser_yang SOURCES schema/test_parser_yang.c)
ly_add_utest(NAME parser_yin SOURCES schema/test_parser_yin.c)
ly_add_utest(NAME tree_schema_compile SOURCES schema/test_tree_schema_compile.c)
ly_add_utest(NAME printer_tree SOURCES schema/test_printer_tree.c)
ly_add_utest(NAME printer_yang SOURCES schema/test_printer_yang.c)
ly_add_utest(NAME printer_yin SOURCES schema/test_printer_yin.c)

ly_add_utest(NAME tree_data SOURCES data/test_tree_data.c)
ly_add_utest(NAME new SOURCES data/test_new.c)
ly_add_utest(NAME parser_xml SOURCES data/test_parser_xml.c)
ly_add_utest(NAME printer_xml SOURCES data/test_printer_xml.c)
ly_add_utest(NAME parser_json SOURCES data/test_parser_json.c)
ly_add_utest(NAME lyb SOURCES data/test_lyb.c)
ly_add_utest(NAME validation SOURCES data/test_validation.c)
ly_add_utest(NAME merge SOURCES data/test_merge.c)
ly_add_utest(NAME diff SOURCES data/test_diff.c)

ly_add_utest(NAME metadata SOURCES extensions/test_metadata.c)
ly_add_utest(NAME nacm SOURCES extensions/test_nacm.c)
ly_add_utest(NAME yangdata SOURCES extensions/test_yangdata.c)

=== tools/lint/CMakeLists.txt ===
# yanglint

set(lintsrc
    main.c
    main_ni.c
    cmd.c
    cmd_add.c
    cmd_clear.c
    cmd_data.c
    cmd_list.c
    cmd_feature.c
    cmd_load.c
    cmd_print.c
    cmd_searchpath.c
    common.c
    completion.c
    configuration.c
    linenoise/linenoise.c)

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    PARENT_SCOPE)

add_executable(yanglint ${lintsrc} ${compatsrc})
target_link_libraries(yanglint yang)
install(TARGETS yanglint DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_SOURCE_DIR}/tools/lint/yanglint.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
target_include_directories(yanglint BEFORE PRIVATE ${PROJECT_BINARY_DIR})

#
# tests
#
function(add_yanglint_test)
    cmake_parse_arguments(ADDTEST "" "NAME;SCRIPT" "" ${ARGN})
    set(TEST_NAME yanglint_${ADDTEST_NAME})

    add_test(NAME ${TEST_NAME} COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tests/${ADDTEST_SCRIPT})
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "YANGLINT=${PROJECT_BINARY_DIR}/yanglint")
endfunction(add_yanglint_test)

if(ENABLE_TESTS)
    # tests of non-interactive mode using shunit2
    find_program(PATH_SHUNIT NAMES shunit2)
    if(NOT PATH_SHUNIT)
        message(WARNING "'shunit2' not found! The yanglint(1) non-interactive tests will not be available.")
    else()
        add_yanglint_test(NAME ni_list SCRIPT shunit2/list.sh)
    endif()

    # tests of interactive mode using expect
    find_program(PATH_EXPECT NAMES expect)
    if(NOT PATH_EXPECT)
        message(WARNING "'expect' not found! The yanglint(1) interactive tests will not be available.")
    else()
#        add_yanglint_test(NAME in_list SCRIPT expect/list.exp)
    endif()
endif()

=== tools/re/CMakeLists.txt ===
# yangre

set(resrc
    main.c)

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    PARENT_SCOPE)

add_executable(yangre ${resrc} ${compatsrc})
target_link_libraries(yangre yang)
install(TARGETS yangre DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_SOURCE_DIR}/tools/re/yangre.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
target_include_directories(yangre BEFORE PRIVATE ${PROJECT_BINARY_DIR})

=== debian/changelog ===
libyang2 (2.0.112-6ubuntu2) jammy; urgency=medium

  * d/t/{control,yangre}: add a DEP8 test for yangre (LP: #1960748)

 -- Andreas Hasenack <andreas@canonical.com>  Sun, 13 Feb 2022 14:18:33 -0300

libyang2 (2.0.112-6ubuntu1) jammy; urgency=medium

  * Enable build time tests (LP: #1958385):
    - d/rules: set -DENABLE_TESTS=ON
    - d/p/fix-test-suite-wrt-FILE.patch: fix test suite failure due
      to __FILE__ being a relative path

 -- Andreas Hasenack <andreas@canonical.com>  Thu, 20 Jan 2022 21:03:40 +0000

libyang2 (2.0.112-6) unstable; urgency=medium

  * Add proper Multi-Arch headers

 -- Ondřej Surý <ondrej@debian.org>  Thu, 25 Nov 2021 10:05:05 +0100

libyang2 (2.0.112-5) unstable; urgency=medium

  * Update the autopkgtest to have separate test directory

 -- Ondřej Surý <ondrej@debian.org>  Wed, 24 Nov 2021 20:40:37 +0100

libyang2 (2.0.112-4) unstable; urgency=medium

  * Fix autopkgtest test file location after package rename

 -- Ondřej Surý <ondrej@debian.org>  Mon, 22 Nov 2021 13:40:45 +0100

libyang2 (2.0.112-3) unstable; urgency=medium

  * Change the libyang2-dev dependency from libpcre3-dev to libpcre2-dev

 -- Ondřej Surý <ondrej@debian.org>  Sat, 13 Nov 2021 16:40:31 +0100

libyang2 (2.0.112-2) unstable; urgency=medium

  * Fix the autopkgtests for libyang2 package

 -- Ondřej Surý <ondrej@debian.org>  Sat, 13 Nov 2021 13:26:48 +0100

libyang2 (2.0.112-1) unstable; urgency=medium

  * New upstream version.

 -- Ondřej Surý <ondrej@debian.org>  Sat, 13 Nov 2021 13:06:00 +0100

libyang2 (2.0.7-1) unstable; urgency=low

  * Initial upload of src:libyang2
  * Rename libyang-tools to libyang2-tools to sync up with RPM
  * Update symbols file

 -- Ondřej Surý <ondrej@debian.org>  Mon, 13 Sep 2021 21:06:35 +0200

libyang2 (2.0.0~-1) unstable; urgency=medium

  * Initial pre-release of libyang2

 -- Ondřej Surý <ondrej@debian.org>  Tue, 04 May 2021 22:20:03 +0200

libyang (1.0.225-1) unstable; urgency=medium

  * New upstream release

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Mar 2021 15:39:56 +0100

libyang (1.0.215-1) unstable; urgency=medium

  * Remove C++ symbols file, it's mostly impossible to maintain
  * Update the libyang1 symbols file with the new symbol

 -- Ondřej Surý <ondrej@debian.org>  Tue, 02 Mar 2021 14:27:37 +0100

libyang (1.0.184-2) unstable; urgency=medium

  * Move the C++ symbols file to be amd64 only (Closes: #969073)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 04 Sep 2020 10:16:16 +0200

libyang (1.0.184-1) unstable; urgency=medium

  * Remove upstream patches merged upstream
  * Update changelog for 1.0.184-1~1.gbp418b5c release
  * Update symbols files for libyang_1.0.184

 -- Ondřej Surý <ondrej@debian.org>  Tue, 21 Jul 2020 16:36:41 +0200

libyang (1.0.176-3) unstable; urgency=medium

  * Add upstream patch for 'data tree BUGFIX hash canonical values for leaves'

 -- Ondřej Surý <ondrej@debian.org>  Sun, 19 Jul 2020 11:00:20 +0200

libyang (1.0.176-2) unstable; urgency=medium

  * Make the C++ symbols human readable
  * Mark symbols missing on Debian jessie as optional
  * Renamed yang-tools package to libyang-tools

 -- Ondřej Surý <ondrej@debian.org>  Wed, 15 Jul 2020 09:35:56 +0200

libyang (1.0.176-1) unstable; urgency=medium

  * New upstream release
  * Add SymbolsHelper-Confirmed header
  * Update symbols files for libyang 1.0.176

 -- Ondřej Surý <ondrej@debian.org>  Mon, 08 Jun 2020 11:21:04 +0200

libyang (1.0.167-1) experimental; urgency=medium

  [ David Lamparter ]
  * major version bump (0.16 -> 1.0)

  [ Ondřej Surý ]
  * Add d/gbp.conf
  * Add README.source on how to work with upstream repository
  * Rediff patches
  * Drop the python bindings
  * Use pkg-kde-tools to regenerate symbols
  * Lower the dh_compat level to 10
  * Add lintian-overrides for the plugins
  * Move the maintainer notes to README.source
  * Add myself to uploaders
  * Add extensions to the libyang1.symbols file

 -- Ondřej Surý <ondrej@debian.org>  Fri, 22 May 2020 10:54:51 +0200

libyang (0.16.105-3) unstable; urgency=medium

  * work around parallel build issues with python bindings (build only change)

 -- David Lamparter <equinox-debian@diac24.net>  Mon, 20 Jan 2020 17:20:21 +0100

libyang (0.16.105-2) unstable; urgency=medium

  * fix CVE-2019-19333 & CVE-2019-19334 (Closes: #946217)
  * fix cache corruption crash (upstream bug 752)
  * fix some gcc & swig version dependent build failures (Closes: #925764)

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 22 Dec 2019 14:27:01 +0100

libyang (0.16.105-1) unstable; urgency=medium

  * upstream 0.16.105 (0.16-r3) release

 -- David Lamparter <equinox-debian@diac24.net>  Wed, 23 Jan 2019 01:32:43 +0100

libyang (0.16.52-2) unstable; urgency=medium

  * use correct DEB_HOST_GNU_TYPE to fix i386 build
  * mark non-libyang C++ symbols as optional (fixes build on several arch)
  * pull in 2 upstraem fixes to get build working on big-endian

 -- David Lamparter <equinox-debian@diac24.net>  Thu, 06 Dec 2018 13:33:08 +0100

libyang (0.16.52-1) unstable; urgency=medium

  * Initial release.
  * Closes: #913219

 -- David Lamparter <equinox-debian@diac24.net>  Sun, 18 Nov 2018 19:30:04 +0100

=== debian/control ===
Source: libyang2
Section: libs
Homepage: https://github.com/CESNET/libyang/
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
Priority: optional
Standards-Version: 4.5.0
Build-Depends: cmake,
               debhelper (>= 10),
               libcmocka-dev <!nocheck>,
               libpcre2-dev,
               pkg-config
Vcs-Browser: https://github.com/CESNET/libyang/tree/libyang2
Vcs-Git: https://github.com/CESNET/libyang.git -b libyang2

Package: libyang2
Depends: ${misc:Depends},
         ${shlibs:Depends}
Architecture: any
Multi-Arch: same
Description: parser toolkit for IETF YANG data modeling - runtime
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 The library is implemented in C and provides an API for other software
 to use in processing configurations.

Package: libyang2-dev
Depends: libpcre2-dev,
         libyang2 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libyang-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Description: parser toolkit for IETF YANG data modeling - development files
 Libyang implements functions to process schemas expressed in the
 YANG data modeling language defined by the IETF in RFCs 6020/7950.
 Schemas expressed in this language primarily describe configuration
 used by larger network equipment like routers and switches.
 .
 In addition to handling the schemas itself, the library also provides
 functions to process data described by the schemas.
 .
 This package contains the C headers, a pkgconfig file, and .so entry point
 for libyang.

Package: libyang2-tools
Depends: libyang2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libyang-tools (<< ${source:Version})
Replaces: libyang-tools (<< ${source:Version})
Section: devel
Architecture: any
Multi-Arch: foreign
Description: parser toolkit for IETF YANG data modeling - executable tools
 This package provides the "yanglint" and "yangre" tools which can be used
 during the creation of IETF YANG schemas.  The tools are not generally
 useful for normal operation where libyang primarily processes configuration
 data, not schemas.

Package: libyang-tools
Depends: libyang2-tools (>= ${source:Version}),
         ${misc:Depends}
Section: oldlibs
Architecture: all
Multi-Arch: foreign
Description: parser toolkit for IETF YANG data modeling [dummy package]
 This is empty dependency package to pull the executable tools.  It's
 safe to remove.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE:String="Release" \
		-DENABLE_TESTS=ON

## libyang2 2.1.30

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-cmake_minimum_required(VERSION 2.8.12)
+if(WIN32)
+    cmake_minimum_required(VERSION 3.22.0)
+else()
+    cmake_minimum_required(VERSION 2.8.12)
+endif()
 
 # force out-of-source build
 if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
@@ -42,11 +46,6 @@
     set(CMAKE_BUILD_TYPE "DocOnly" CACHE STRING "Build Type" FORCE)
 endif()
 
-# check the supported platform
-if(NOT UNIX)
-    message(FATAL_ERROR "Only *nix like systems are supported.")
-endif()
-
 #
 # variables
 #
@@ -61,20 +60,26 @@
 
 # set version of the project
 set(LIBYANG_MAJOR_VERSION 2)
-set(LIBYANG_MINOR_VERSION 0)
-set(LIBYANG_MICRO_VERSION 112)
+set(LIBYANG_MINOR_VERSION 1)
+set(LIBYANG_MICRO_VERSION 30)
 set(LIBYANG_VERSION ${LIBYANG_MAJOR_VERSION}.${LIBYANG_MINOR_VERSION}.${LIBYANG_MICRO_VERSION})
 # set version of the library
 set(LIBYANG_MAJOR_SOVERSION 2)
-set(LIBYANG_MINOR_SOVERSION 13)
-set(LIBYANG_MICRO_SOVERSION 7)
+set(LIBYANG_MINOR_SOVERSION 29)
+set(LIBYANG_MICRO_SOVERSION 2)
 set(LIBYANG_SOVERSION_FULL ${LIBYANG_MAJOR_SOVERSION}.${LIBYANG_MINOR_SOVERSION}.${LIBYANG_MICRO_SOVERSION})
 set(LIBYANG_SOVERSION ${LIBYANG_MAJOR_SOVERSION})
 
-# global C flags
-set(CMAKE_C_FLAGS                "${CMAKE_C_FLAGS} -Wall -Wextra -Wpedantic -std=c11")
-
-include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_SOURCE_DIR}/src)
+if(WIN32)
+    set(C_STANDARD 11)
+    set(C_STANDARD_REQUIRED ON)
+    set(CMAKE_C_FLAGS "/Zc:preprocessor /W3 /wd4711 /w14013 /utf-8 ${CMAKE_C_FLAGS}")
+else()
+    # global C flags
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Wpedantic -std=c11")
+endif()
+
+include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/src/plugins_exts)
 
 # type plugins are separate because they have their documentation generated
 set(type_plugins
@@ -86,6 +91,7 @@
     src/plugins_types/enumeration.c
     src/plugins_types/identityref.c
     src/plugins_types/instanceid.c
+    src/plugins_types/instanceid_keys.c
     src/plugins_types/integer.c
     src/plugins_types/leafref.c
     src/plugins_types/string.c
@@ -111,8 +117,9 @@
     src/json.c
     src/tree_data.c
     src/tree_data_free.c
-    src/tree_data_helpers.c
+    src/tree_data_common.c
     src/tree_data_hash.c
+    src/tree_data_new.c
     src/parser_xml.c
     src/parser_json.c
     src/parser_lyb.c
@@ -127,12 +134,12 @@
     src/schema_features.c
     src/tree_schema.c
     src/tree_schema_free.c
-    src/tree_schema_helpers.c
+    src/tree_schema_common.c
     src/in.c
     src/lyb.c
+    src/parser_common.c
     src/parser_yang.c
     src/parser_yin.c
-    src/parser_stmt.c
     src/printer_schema.c
     src/printer_yang.c
     src/printer_yin.c
@@ -143,6 +150,8 @@
     src/plugins_exts/metadata.c
     src/plugins_exts/nacm.c
     src/plugins_exts/yangdata.c
+    src/plugins_exts/schema_mount.c
+    src/plugins_exts/structure.c
     src/xml.c
     src/xpath.c
     src/validation.c
@@ -159,8 +168,7 @@
     src/parser_schema.h
     src/plugins.h
     src/plugins_exts.h
-    src/plugins_exts_compile.h
-    src/plugins_exts_print.h
+    src/plugins_exts/metadata.h
     src/plugins_types.h
     src/printer_data.h
     src/printer_schema.h
@@ -231,6 +239,7 @@
 option(ENABLE_COVERAGE "Build code coverage report from tests" OFF)
 option(ENABLE_FUZZ_TARGETS "Build target programs suitable for fuzzing with AFL" OFF)
 option(ENABLE_INTERNAL_DOCS "Generate doxygen documentation also from internal headers" OFF)
+set(YANG_MODULE_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATADIR}/yang/modules/libyang" CACHE STRING "Directory where to copy the YANG modules to")
 
 if(ENABLE_INTERNAL_DOCS)
     set(doxy_files ${doxy_files} ${internal_headers})
@@ -305,7 +314,7 @@
 
 if ("${BUILD_TYPE_UPPER}" STREQUAL "DEBUG")
     # enable before adding tests to let them detect that format checking is available - one of the tests is format checking
-    source_format_enable()
+    source_format_enable(0.76)
 endif()
 
 # generate files
@@ -337,17 +346,46 @@
 else()
     set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)
     add_library(yangobj OBJECT ${libsrc} ${compatsrc})
-    set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
+    if(NOT WIN32)
+        set_target_properties(yangobj PROPERTIES COMPILE_FLAGS "-fvisibility=hidden")
+    endif()
+    target_compile_definitions(yangobj PRIVATE LIBYANG_BUILD)
     add_library(yang SHARED $<TARGET_OBJECTS:yangobj>)
+
+    if(WIN32)
+        find_package(dlfcn-win32 REQUIRED)
+        set(CMAKE_DL_LIBS dlfcn-win32::dl)
+    endif()
 
     #link dl
     target_link_libraries(yang ${CMAKE_DL_LIBS})
 endif()
 
+if(WIN32)
+    find_path(DIRENT_INCLUDE_DIR NAMES dirent.h REQUIRED)
+    message(STATUS "Found <dirent.h> at ${DIRENT_INCLUDE_DIR}")
+
+    set(COMPAT_POSIX_INCLUDES
+        ${CMAKE_CURRENT_SOURCE_DIR}/compat/posix-shims
+        ${DIRENT_INCLUDE_DIR})
+
+    if(TARGET yangobj)
+        target_include_directories(yangobj PRIVATE ${COMPAT_POSIX_INCLUDES})
+    endif()
+    target_include_directories(yang PRIVATE ${COMPAT_POSIX_INCLUDES})
+    include_directories(${COMPAT_POSIX_INCLUDES})
+
+    find_package(pthreads REQUIRED)
+    set(COMPAT_WIN_LIBRARIES PThreads4W::PThreads4W shlwapi.lib ws2_32)
+    target_link_libraries(yang ${COMPAT_WIN_LIBRARIES})
+endif()
+
 set_target_properties(yang PROPERTIES VERSION ${LIBYANG_SOVERSION_FULL} SOVERSION ${LIBYANG_SOVERSION})
 
-# link math
-target_link_libraries(yang m)
+if(NOT WIN32)
+    # link math
+    target_link_libraries(yang m)
+endif()
 
 # find pthreads
 set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
@@ -358,31 +396,3 @@
     target_link_libraries(yang ${CMAKE_THREAD_LIBS_INIT})
 endif()
 
-# find PCRE2 library
-unset(PCRE2_LIBRARY CACHE)
-find_package(PCRE2 10.21 REQUIRED)
-include_directories(${PCRE2_INCLUDE_DIRS})
-target_link_libraries(yang ${PCRE2_LIBRARIES})
-
-# generated header list
-foreach(h IN LISTS gen_headers)
-    list(APPEND g_headers ${PROJECT_BINARY_DIR}/${h})
-endforeach()
-
-# install all library files
-install(TARGETS yang DESTINATION ${CMAKE_INSTALL_LIBDIR})
-install(FILES ${headers} ${g_headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libyang)
-
-find_package(PkgConfig)
-if(PKG_CONFIG_FOUND)
-    # generate and install pkg-config file
-    configure_file("libyang.pc.in" "libyang.pc" @ONLY)
-    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libyang.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
-    # check that pkg-config includes the used path
-    execute_process(COMMAND ${PKG_CONFIG_EXECUTABLE} --variable pc_path pkg-config RESULT_VARIABLE RETURN OUTPUT_VARIABLE PC_PATH ERROR_QUIET)
-    if(RETURN EQUAL 0)
-    string(STRIP "${PC_PATH}" PC_PATH)
-    set(PC_PATH "${PC_PATH}:$ENV{PKG_CONFIG_PATH}")
-        string(REGEX MATCH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig" SUBSTR "${PC_PATH}")
-        string(LENGTH "${SUBSTR}" SUBSTR_LEN)
-        if(SUBSTR_LEN EQUAL 0)

=== tests/CMakeLists.txt ===
# Correct RPATH usage on OS X
set(CMAKE_MACOSX_RPATH TRUE)

configure_file("${PROJECT_SOURCE_DIR}/tests/tests_config.h.in" "${PROJECT_BINARY_DIR}/tests/tests_config.h" ESCAPE_QUOTES @ONLY)
include_directories(SYSTEM ${CMOCKA_INCLUDE_DIR})
include_directories(${PROJECT_BINARY_DIR}/tests/)

function(ly_add_utest)
    cmake_parse_arguments(ADDTEST "" "NAME;WRAP" "SOURCES" ${ARGN})
    set(TEST_NAME utest_${ADDTEST_NAME})

    foreach(TEST_SOURCE ${ADDTEST_SOURCES})
        list(APPEND TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/${TEST_SOURCE})
    endforeach()

    add_executable(${TEST_NAME} ${TEST_SOURCES} $<TARGET_OBJECTS:yangobj>)
    target_compile_definitions(${TEST_NAME} PRIVATE LIBYANG_BUILD)

    # Set common attributes of all tests
    set_target_properties(${TEST_NAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests")
    target_link_libraries(${TEST_NAME} ${CMOCKA_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT} ${PCRE2_LIBRARIES} ${CMAKE_DL_LIBS})
    if (NOT WIN32)
        target_link_libraries(${TEST_NAME} m)
    else()
        target_link_libraries(${TEST_NAME} ${COMPAT_WIN_LIBRARIES})
    endif()
    if (NOT APPLE)
        if (ADDTEST_WRAP)
            set_target_properties(${TEST_NAME} PROPERTIES LINK_FLAGS "${ADDTEST_WRAP}")
        endif()
    endif()

    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "MALLOC_CHECK_=3")

    if(ENABLE_VALGRIND_TESTS)
        add_test(${TEST_NAME}_valgrind valgrind --leak-check=full --show-leak-kinds=all --suppressions=${PROJECT_SOURCE_DIR}/tests/ld.supp --error-exitcode=1 ${CMAKE_BINARY_DIR}/tests/${TEST_NAME})
    endif()
endfunction()

if(ENABLE_TESTS)
    add_subdirectory(plugins)
    add_subdirectory(utests)
    if(NOT WIN32)
        add_subdirectory(style)
        add_subdirectory(fuzz)
    endif()
endif()
if(ENABLE_PERF_TESTS)
    add_subdirectory(perf)
endif()

set(format_sources ${format_sources} PARENT_SCOPE)

=== tests/style/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
     COMMAND ${CMAKE_SOURCE_DIR}/compat/check_includes.sh ${CMAKE_SOURCE_DIR}/src/ ${CMAKE_SOURCE_DIR}/tools/lint/ ${CMAKE_SOURCE_DIR}/tools/re/)
 
 if (${SOURCE_FORMAT_ENABLED})
-    add_test(NAME format WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND make format-check)
+    add_test(NAME format WORKING_DIRECTORY ${CMAKE_BINARY_DIR} COMMAND cmake --build ${CMAKE_BINARY_DIR} --target format-check)
 endif()
 
 # just compile

=== tests/utests/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/data/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/extensions/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.c
-    ${CMAKE_CURRENT_SOURCE_DIR}/schema/*.h
     ${CMAKE_CURRENT_SOURCE_DIR}/types/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/restriction/*.c
     ${CMAKE_CURRENT_SOURCE_DIR}/node/*.c
@@ -29,6 +28,7 @@
 ly_add_utest(NAME yang_types   SOURCES types/yang_types.c)
 ly_add_utest(NAME enumeration  SOURCES types/enumeration.c)
 ly_add_utest(NAME instanceid   SOURCES types/instanceid.c)
+ly_add_utest(NAME instanceid_keys   SOURCES types/instanceid_keys.c)
 ly_add_utest(NAME union        SOURCES types/union.c)
 ly_add_utest(NAME boolean      SOURCES types/boolean.c)
 ly_add_utest(NAME decimal64    SOURCES types/decimal64.c)
@@ -46,19 +46,19 @@
 ly_add_utest(NAME hash_table SOURCES basic/test_hash_table.c)
 ly_add_utest(NAME inout SOURCES basic/test_inout.c)
 ly_add_utest(NAME context SOURCES basic/test_context.c)
+if(NOT WIN32)
 ly_add_utest(NAME plugins SOURCES basic/test_plugins.c)
+endif()
 ly_add_utest(NAME xml SOURCES basic/test_xml.c)
 ly_add_utest(NAME json SOURCES basic/test_json.c)
 ly_add_utest(NAME xpath SOURCES basic/test_xpath.c)
 ly_add_utest(NAME yanglib SOURCES basic/test_yanglib.c)
 
-ly_add_utest(NAME schema SOURCES schema/test_schema.c schema/test_schema_common.c schema/test_schema_stmts.c schema/test_schema_extensions.c)
-ly_add_utest(NAME parser_yang SOURCES schema/test_parser_yang.c)
-ly_add_utest(NAME parser_yin SOURCES schema/test_parser_yin.c)
+ly_add_utest(NAME schema SOURCES schema/test_schema.c)
+ly_add_utest(NAME yang SOURCES schema/test_yang.c)
+ly_add_utest(NAME yin SOURCES schema/test_yin.c)
 ly_add_utest(NAME tree_schema_compile SOURCES schema/test_tree_schema_compile.c)
 ly_add_utest(NAME printer_tree SOURCES schema/test_printer_tree.c)
-ly_add_utest(NAME printer_yang SOURCES schema/test_printer_yang.c)
-ly_add_utest(NAME printer_yin SOURCES schema/test_printer_yin.c)
 
 ly_add_utest(NAME tree_data SOURCES data/test_tree_data.c)
 ly_add_utest(NAME new SOURCES data/test_new.c)
@@ -73,3 +73,5 @@
 ly_add_utest(NAME metadata SOURCES extensions/test_metadata.c)
 ly_add_utest(NAME nacm SOURCES extensions/test_nacm.c)
 ly_add_utest(NAME yangdata SOURCES extensions/test_yangdata.c)
+ly_add_utest(NAME schema_mount SOURCES extensions/test_schema_mount.c)
+ly_add_utest(NAME structure SOURCES extensions/test_structure.c)

=== tools/lint/CMakeLists.txt ===
# yanglint

if(WIN32)
    set(YANGLINT_INTERACTIVE OFF)
else()
    set(YANGLINT_INTERACTIVE ON)
endif()

set(lintsrc
    main_ni.c
    cmd.c
    cmd_add.c
    cmd_clear.c
    cmd_data.c
    cmd_list.c
    cmd_feature.c
    cmd_load.c
    cmd_print.c
    cmd_searchpath.c
    common.c
)
if(YANGLINT_INTERACTIVE)
    set(lintsrc ${lintsrc}
        main.c
        completion.c
        configuration.c
        linenoise/linenoise.c)
else()
    set(lintsrc ${lintsrc}
        main_ni_only.c)
endif()

set(format_sources
    ${format_sources}
    ${CMAKE_CURRENT_SOURCE_DIR}/*.c
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    PARENT_SCOPE)

add_executable(yanglint ${lintsrc} ${compatsrc})
target_link_libraries(yanglint yang)
install(TARGETS yanglint DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${PROJECT_SOURCE_DIR}/tools/lint/yanglint.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
target_include_directories(yanglint BEFORE PRIVATE ${PROJECT_BINARY_DIR})

if(WIN32)
    target_include_directories(yanglint PRIVATE ${GETOPT_INCLUDE_DIR})
    target_link_libraries(yanglint ${GETOPT_LIBRARY})
endif()

#
# tests
#
function(add_yanglint_test)
    cmake_parse_arguments(ADDTEST "" "NAME;VIA;SCRIPT" "" ${ARGN})
    set(TEST_NAME yanglint_${ADDTEST_NAME})

    if(${ADDTEST_VIA} STREQUAL "bash")
        set(WRAPPER /usr/bin/env bash)
    elseif(${ADDTEST_VIA} STREQUAL "expect")
        set(WRAPPER ${PATH_EXPECT})
    else()
        message(FATAL_ERROR "build: unexpected wrapper '${ADDTEST_VIA}'")
    endif()

    add_test(NAME ${TEST_NAME} COMMAND ${WRAPPER} ${CMAKE_CURRENT_SOURCE_DIR}/tests/${ADDTEST_SCRIPT})
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "YANGLINT=${PROJECT_BINARY_DIR}/yanglint")
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "YANG_MODULES_DIR=${PROJECT_SOURCE_DIR}/tests/modules/yang")
    set_property(TEST ${TEST_NAME} APPEND PROPERTY ENVIRONMENT "CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}")
endfunction(add_yanglint_test)

if(ENABLE_TESTS)
    # tests of non-interactive mode using shunit2
    find_program(PATH_SHUNIT NAMES shunit2)
    if(NOT PATH_SHUNIT)
        message(WARNING "'shunit2' not found! The yanglint(1) non-interactive tests will not be available.")
    else()
        add_yanglint_test(NAME ni_list VIA bash SCRIPT shunit2/list.sh)
        add_yanglint_test(NAME ni_feature VIA bash SCRIPT shunit2/feature.sh)
    endif()

    # tests of interactive mode using expect
    find_program(PATH_EXPECT NAMES expect)
    if(NOT PATH_EXPECT)
        message(WARNING "'expect' not found! The yanglint(1) interactive tests will not be available.")
    elseif(YANGLINT_INTERACTIVE)
        add_yanglint_test(NAME in_list VIA expect SCRIPT expect/list.exp)
        add_yanglint_test(NAME in_feature VIA expect SCRIPT expect/feature.exp)
        add_yanglint_test(NAME in_completion VIA expect SCRIPT expect/completion.exp)
    endif()
endif()

=== debian/changelog ===
libyang2 (2.1.30-2.1ubuntu0.1) noble-security; urgency=medium

  * SECURITY UPDATE: NULL pointer deref in lys_parse_mem
    - debian/patches/CVE-2023-26916.patch: schema compile UPDATE do not
      implement 2 same modules in src/schema_compile.c.
    - CVE-2023-26916
  * SECURITY UPDATE: NULL pointer deref in lysp_stmt_validate_value
    - debian/patches/CVE-2023-26917.patch: parser common BUGFIX handle
      missing YANG strings in src/parser_common.c.
    - CVE-2023-26917

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 12 Sep 2025 12:40:50 -0400

libyang2 (2.1.30-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:22:15 +0000

libyang2 (2.1.30-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062738

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:25:05 +0000

libyang2 (2.1.30-2) unstable; urgency=medium

  * Non-maintainer upload.
  * d/t/{control,yangre}: add a DEP8 test for yangre.

 -- Utkarsh Gupta <utkarsh@debian.org>  Wed, 01 Feb 2023 14:44:51 +0530

libyang2 (2.1.30-1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
    + Fixes a bug and test suite failure on big endian architectures.

 -- Marco d'Itri <md@linux.it>  Wed, 18 Jan 2023 15:41:16 +0100

libyang2 (2.1.4-2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backported the upstream commit 118eb52 to fix a bug and test suite
    failure on big endian architectures.

 -- Marco d'Itri <md@linux.it>  Fri, 13 Jan 2023 03:20:45 +0100

libyang2 (2.1.4-1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release. (Closes: #1023794)
  * Enable the build time tests. (Closes: #1004191)

 -- Marco d'Itri <md@linux.it>  Fri, 06 Jan 2023 18:40:33 +0100

=== debian/control ===
--- 
+++ 
@@ -5,15 +5,18 @@
 XSBC-Original-Maintainer: Ondřej Surý <ondrej@debian.org>
 Priority: optional
 Standards-Version: 4.5.0
-Build-Depends: cmake,
-               debhelper (>= 10),
+Build-Depends: dpkg-dev (>= 1.22.5), cmake,
+               debhelper-compat (= 13),
                libcmocka-dev <!nocheck>,
                libpcre2-dev,
                pkg-config
-Vcs-Browser: https://github.com/CESNET/libyang/tree/libyang2
-Vcs-Git: https://github.com/CESNET/libyang.git -b libyang2
+Vcs-Browser: https://salsa.debian.org/netconf-team/libyang2
+Vcs-Git: https://salsa.debian.org/netconf-team/libyang2.git -b debian/master
 
-Package: libyang2
+Package: libyang2t64
+Provides: ${t64:Provides}
+Replaces: libyang2
+Breaks: libyang2 (<< ${source:Version})
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Architecture: any
@@ -32,7 +35,7 @@
 
 Package: libyang2-dev
 Depends: libpcre2-dev,
-         libyang2 (= ${binary:Version}),
+         libyang2t64 (= ${binary:Version}),
          ${misc:Depends}
 Conflicts: libyang-dev
 Section: libdevel
@@ -51,7 +54,7 @@
  for libyang.
 
 Package: libyang2-tools
-Depends: libyang2 (= ${binary:Version}),
+Depends: libyang2t64 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Breaks: libyang-tools (<< ${source:Version})

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libyang-$1.tar.gz%" \
    https://github.com/CESNET/libyang/tags \
    (?:.*?/)?v?(\d[\d.]*)(?:-r\d+)?\.tar\.gz debian uupdate
